/* Function for allostdscrg a printscreen from inside tn3270 */

/*
   A few defines, replace TMPDIR with your temp directory, and
   PRINTCMD with the command you want to use for printing.
*/
#ifdef PRINTSCREEN

#include <stdlib.h>
#include <stdio.h>
#include <curses.h>
#include <unistd.h> 
#include <fcntl.h>

#include "../general/general.h"
#include "../config.h"

#include "hostctlr.h"
#include "oia.h"
#include "screen.h"
#include "../api/ebc_disp.h"

#include "../general/globals.h"
#include "externs.h"
#include "declare.h"

void PrintScreen(void)
{
	FILE *fp;
	chtype	*temp1;
	chtype	*end;
	int	r,c;
	char 	fname[256];
	char	prtcmd[256];
	char	*printer,*tmpdir;
	int	fd;

	umask(600);

	if ((printer = getenv("PRINT")) == NULL) printer = PRINTCMD;
	if ((tmpdir = getenv("TMPDIR")) == NULL) tmpdir = PRINTDIR;

	sprintf(fname,"%s/tn3270prt.%d",tmpdir,getpid());
	
	fd=open(fname, O_WRONLY|O_EXCL|O_TRUNC|O_CREAT, 0600);
	
	if(fd == -1 || (fp = fdopen(fd,"w")) == NULL) {
		RingBell("Could not open print screen file");
		return;
	}

	for (r = 0; r < stdscr->_maxy; r++) {
		temp1 = &stdscr->_line[r].text[0];
		end = &stdscr->_line[r].text[stdscr->_maxx];
		while (temp1 <= end) {
			fprintf(fp,"%c",((*temp1) & 0x7f));
			*temp1++; 
		}
		fprintf(fp,"\n");
	} 

	fclose(fp);
	
	sprintf(prtcmd,"%s %s",printer,fname);	
	if ((system(prtcmd)) != 0) {
		RingBell("There was an error printing the screen");
	}
	unlink(fname);
 }

#else

void PrintScreen(void)
{
	RingBell("Print screen not supported");
}

#endif
